<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Pizza 365 | Drinks</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">

  <!-- Preloader -->    

  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Vũ Duy Dũng</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="indexDrink2.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="indexMenu2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Drinks</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Drink</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h3 class="text-center text-primary">Quản trị vouchers</h3>
        <div class="jumbotron">
            <div class="row form-group">
                <label for="" class="col-sm-3">Mã Voucher</label>
                <div class="col-sm-9">
                    <input id="inp-voucher-code" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Phần trăm giảm giá</label>
                <div class="col-sm-9">
                    <input id="inp-discount-percent" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ghi chú</label>
                <div class="col-sm-9">
                    <input id="inp-note" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày tạo</label>
                <div class="col-sm-9">
                    <input id="inp-create-date" type="date" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày sửa</label>
                <div class="col-sm-9">
                    <input id="inp-update-date" type="date" class="form-control">
                </div>
            </div>
            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa Voucher</button>

        </div>

        <table id="table-vouchers" class="table table-bordered table-stripped table-hover">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã Giảm Giá</th>
                    <th>Phần Trăm Giảm Giá</th>
                    <th>Ghi Chú</th>
                    <th>Ngày Tạo</th>
                    <th>Ngày Cập Nhật</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
    </section>
    <!-- /.content -->
    <!-- Modal delete -->
<div class="modal fade" id="modal-delete" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <h5>Bạn có chắc chắn muốn xóa loại nước này?</h5>
        </div>
        <div class="modal-footer">
          <button id="btn-confirm" type="button" class="btn btn-primary">Xác nhận</button>
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </div>
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
  var gTableVouchers = $("#table-vouchers").DataTable({
      columns: [
          { data: "id"},
          { data: "maVoucher"},
          { data: "phanTramGiamGia"},
          { data: "ghiChu"},
          { data: "ngayTao"},
          { data: "ngayCapNhat"}
      ],
      columnDefs: [
          {
              targets: 0,
              render: function() {
                  return gStt++;
              }
          }
      ]
  });

  var gStt = 1;
  var gVoucherId = null;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();

  // Thực thi sự kiện nhấn vào row trong datatable
  $("#table-vouchers").on("click", "tr", function() {
      onClickRowVoucher(this);
  });

  // Thực thi sự kiện nhấn nút tạo mới voucher 
  $("#btn-add").on("click", function(){
      onBtnAddNewVoucherClick();
  });

  // Thực thi sự kiện nhấn nút cập nhật voucher 
  $("#btn-update").on("click", function(){
      onBtnUpdateVoucherClick();
  });

  // Thực thi sự kiện nhấn nút xóa voucher 
  $("#btn-delete").on("click", function(){
      $("#modal-delete").modal("show");
  });

  // Thực thi sự kiện xác nhận xóa trong modal delete
  $("#btn-confirm").on("click", function() {
      onBtnDeleteVoucher();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
      callApiToLoadListVoucher();
  }

  // Hàm sự kiện nhấn vào row voucher
  function onClickRowVoucher(paramRow) {
      var vDataRow = gTableVouchers.row(paramRow).data();
      $("#inp-voucher-code").val(vDataRow.maVoucher);
      $("#inp-discount-percent").val(vDataRow.phanTramGiamGia);
      $("#inp-note").val(vDataRow.ghiChu);
      $("#inp-create-date").val(formatDate(vDataRow.ngayTao));
      if(vDataRow.ngayCapNhat != null) {
          $("#inp-update-date").val(formatDate(vDataRow.ngayCapNhat));
      }
      else {
          $("#inp-update-date").val(vDataRow.ngayCapNhat);
      }

      $("#btn-add").hide();
      $("#btn-update").show();
      $("#btn-delete").show();
      gVoucherId = vDataRow.id;
  }


  // Hàm xử lý sự kiện nhấn nút thêm mới voucher
  function onBtnAddNewVoucherClick() {
      var vVoucher = {
          maVoucher: "",
          phanTramGiamGia: "",
          ghiChu: ""
      }

      getVoucherData(vVoucher);
      var vValidate = validateVoucher(vVoucher);
      if(vValidate) {
          callApiToCreateNewVoucher(vVoucher);
      }
  }

  // Hàm xử lý sự kiện nhấn nút sửa 1 voucher
  function onBtnUpdateVoucherClick() {
      var vVoucher = {
          maVoucher: "",
          phanTramGiamGia: "",
          ghiChu: ""
      }

      getVoucherData(vVoucher);
      var vValidate = validateVoucher(vVoucher);
      if(vValidate) {
          console.log(gVoucherId);
          callApiToUpdateVoucher(vVoucher);
      }
  }

  // Hàm nhấn nút delete voucher
  function onBtnDeleteVoucher() {
      $.ajax({
          type: "DELETE",
          url: "http://localhost:8080/vouchers/" + gVoucherId,
          success: function(paramRes) {
              alert("Voucher đã bị xóa!");
              callApiToLoadListVoucher();
              resetFormVoucher();
              $("#modal-delete").modal("hide");
          },
          error: function(paramError) {
              console.log(paramError.status);
              alert("Xóa voucher thất bại, vui lòng thử lại!");
              $("#modal-delete").modal("hide");
          }
      })
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  // Hàm gọi APi để load dữ liệu voucher vào table
  function callApiToLoadListVoucher() {
      $.ajax({
          type: "GET",
          url: "http://localhost:8080/vouchers",
          success: function(paramRes) {
              console.log(paramRes);
              loadDataToTable(paramRes);
          },
          error: function(paramError) {
              console.log(paramError.status);
          }
      })
  }

  // Hàm load dữ liệu vào table
  function loadDataToTable(paramVoucherData) {
      gStt = 1;
      gTableVouchers.clear();
      gTableVouchers.rows.add(paramVoucherData);
      gTableVouchers.draw();
  }

  // Hàm format lại ngày tháng
  function formatDate(paramDate) {
      var vDate = paramDate.split("-");
      return vDate[2]+ "-" + vDate[1] + "-" + vDate[0];
  }

  // Hàm lấy dữ liệu voucher từ form
  function getVoucherData(paramVoucherData) {
      paramVoucherData.maVoucher = $("#inp-voucher-code").val();
      paramVoucherData.phanTramGiamGia = $("#inp-discount-percent").val();
      paramVoucherData.ghiChu = $("#inp-note").val();
  }

  // Hàm validate dữ liệu
  function validateVoucher(paramVoucherData) {
      if(paramVoucherData.maVoucher == "") {
          alert("Vui lòng nhập mã voucher!");
          return false;
      }
      if(paramVoucherData.phanTramGiamGia == "") {
          alert("Nhập phần trăm giảm giá");
          return false;
      }
      if(paramVoucherData.phanTramGiamGia < 0 || paramVoucherData.phanTramGiamGia >= 100 ) {
          alert("Phần trăm giảm giá phải từ 0 đến 100!");
          return false;
      }

      return true;
  }

  // Hàm gọi api để thêm mới voucher  
  function callApiToCreateNewVoucher(paramVoucherData) {
      $.ajax({
          type: "POST",
          url: "http://localhost:8080/vouchers",
          contentType: "application/json",
          data: JSON.stringify(paramVoucherData),
          success: function(paramRes) {
              alert("Tạo mới voucher thành công!");
              resetFormVoucher();
              callApiToLoadListVoucher();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }

  // Hàm reset form voucher
  function resetFormVoucher() {
      $("#inp-voucher-code").val("");
      $("#inp-discount-percent").val("");
      $("#inp-note").val("");
      $("#inp-create-date").val("");
      $("#inp-update-date").val("");


      $("#btn-add").show();
      $("#btn-update").hide();
      $("#btn-delete").hide();
  }

  // Hàm gọi API để sửa 1 voucher
  function callApiToUpdateVoucher(paramVoucherData) {
      $.ajax({
          type: "PUT",
          url: "http://localhost:8080/vouchers/" + gVoucherId,
          contentType: "application/json",
          data: JSON.stringify(paramVoucherData),
          success: function(paramRes) {
              alert("Cập nhật voucher thành công!");
              resetFormVoucher();
              callApiToLoadListVoucher();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }


</script>
</body>
</html>
